<template>
    <section>

        <h2>Edit Content</h2>

        <template v-if="pageLoading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="pageLoading"><i class="fas fa-spinner fa-spin"></i></span>
                <span class="h4" v-if="fail">
                    {{ fail.message }} <br>
                    <a href="#" class="btn btn-outline-primary mt-3" v-on:click.prevent="loadContent">Retry</a>
                </span>
            </div>
        </template>
        <template v-else>
            <form>

            <h4>Choose a Platform</h4>

            <div class="row mx-0">

                <div class="col-12 col-md-4 col-lg-3 p-1">
                    <div v-bind:class="['card', 'content-type-card', 'content-type-android',  {'active' : type === 'android' }]" v-on:click.prevent="contentTypeClicked('android')">
                        <div class="card-body text-center">
                            <i class="text-center fab fa-android"></i>
                            <span class="content-type-card-label">Android</span>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-4 col-lg-3 p-1">
                    <div v-bind:class="['card', 'content-type-card', 'content-type-telegram',  {'active' : type === 'telegram' }]" v-on:click.prevent="contentTypeClicked('telegram')">
                        <div class="card-body text-center">
                            <i class="text-center fab fa-telegram-plane"></i>
                            <span class="content-type-card-label">Telegram</span>
                        </div>
                    </div>
                </div>

                <div class="col-12 col-md-4 col-lg-3 p-1">
                    <div v-bind:class="['card', 'content-type-card', 'content-type-web',  {'active' : type === 'website' }]" v-on:click.prevent="contentTypeClicked('website')">
                        <div class="card-body text-center">
                            <i class="text-center fas fa-globe"></i>
                            <span class="content-type-card-label">Website</span>
                        </div>
                    </div>
                </div>

            </div>

            <template v-if="validationError && validationError.type">
                <span class="text-small text-danger">
                    <strong>{{ validationError.type[0] }}</strong>
                </span>
            </template>

            <span class="p-3"></span>

            <div class="row">
                <div class="col-12 col-lg-9">

                    <div class="form-group">
                        <label for="nameInput">Name</label>
                        <input type="text" v-model="name" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.name}]" id="nameInput" placeholder="Eg: Gebeta">

                        <template v-if="validationError && validationError.name">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.name[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="locationInput">Location</label>
                        <input type="text" v-model="location" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.location}]" id="locationInput" placeholder="Eg: tk.nybapps.gebeta">

                        <template v-if="validationError && validationError.location">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.location[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="categorySelect">Content Category</label>
                        <select id="categorySelect" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.category}]" v-model="category">
                            <option v-bind:value="category.id" v-for="category in categories">{{ category.name }}</option>
                        </select>

                        <template v-if="validationError && validationError.category">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.category[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <hr>

                    <h4 class="font-weight-bold">YOUR AUDIENCE</h4>

                    <div class="form-group">
                        <label for="genderInput">Gender</label>

                        <div id="genderInput" v-bind:class="['row',  {'is-invalid' : validationError && validationError.gender}]">

                            <div class="col-md-4 pr-0 mb-2">
                                <div v-bind:class="['card', 'select-gender-card',  {'active' : maleSelected }]" v-on:click.prevent="genderSelected('male')">
                                    <div class="card-body p-2">
                                        Male  <span class="float-right" v-if="maleSelected"><i class="fas fa-check"></i></span>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 pr-0 mb-2">
                                <div v-bind:class="['card', 'select-gender-card',  {'active' : femaleSelected }]" v-on:click.prevent="genderSelected('female')">
                                    <div class="card-body p-2">
                                        Female  <span class="float-right" v-if="femaleSelected"><i class="fas fa-check"></i></span>
                                    </div>
                                </div>
                            </div>

                        </div>

                        <template v-if="validationError && validationError.gender">
                            <span class="text-small text-danger">
                                <strong>{{ validationError.gender[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="ageRangeInput">Age Range</label>

                        <div class="row mx-0" id="ageRangeInput">

                            <input type="number" class="form-control col-md-4" min="18" max="100" v-model="ageRangeMin" placeholder="From">

                            <input type="number" class="form-control col-md-4 ml-3" min="19" max="100" v-model="ageRangeMax" placeholder="To">


                        </div>
                    </div>

                    <hr>

                    <div class="alert alert-success" v-if="success">
                        {{ success.message }}
                        <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <button type="submit" class="btn btn-primary" v-on:click.prevent="editContent" v-if="!loading">SAVE CHANGES</button>
                    <button type="submit" class="btn btn-primary" v-else disabled><i class="fas fa-spinner fa-spin"></i> SAVE CHANGES</button>

                </div>
            </div>


        </form>
        </template>
    </section>
</template>

<script>
    export default {
        data: function() {
            return {
                // Form inputs
                name: '',
                location: '',
                type: '',
                category: '',
                //gender: '',
                ageRangeMin: '',
                ageRangeMax: '',

                content: '',
                contentId: this.$route.params.id,

                // Selected Gender
                maleSelected: false,
                femaleSelected: false,

                // List of categories to be selected from
                categories: [
                    {'id' : 1, 'name' : 'Art and Design'},
                    {'id' : 2, 'name' : 'Auto and Vehicles'}
                ],

                // Loading flag
                loading: false,
                pageLoading: false,

                // Validation Error
                validationError: '',

                //
                success: false,
                fail: false,

            }
        },
        methods: {
            loadCategories: function() {

            },
            contentTypeClicked: function(contentType) {
                //this.type = contentType === this.type ? null : contentType;
            },
            genderSelected: function(gender) {
                console.log(gender);
                if (gender === 'female') {
                    console.log('Got here' + this.femaleSelected);
                    this.femaleSelected = !this.femaleSelected;
                    console.log('Got here 2 ' + this.femaleSelected);
                } else {
                    this.maleSelected = !this.maleSelected;
                }
            },
            editContent: function() {
                // Show loading
                this.loading = true;

                // Clear previous flags and messages
                this.success = '';
                this.fail = '';
                this.validationError = '';

                // Validate Gender, Category and Type
                // Check that a gender is selected
                if (!this.gender) {
                    this.validationError = {
                        'gender': ['Select at least one gender.']
                    };
                    this.loading = false;
                    return;
                }

                // Check that a category is selected
                if (!this.category) {
                    this.validationError = {
                        'category': ['Select a category.']
                    };
                    this.loading = false;
                    return;
                }

                // Check that a type is selected
                if (!this.type) {
                    this.validationError = {
                        'type': ['You must select a content type.']
                    };
                    this.loading = false;
                    return;
                }

                // Make a request to the server
                axios.post('/api/publisher/content/' + this.contentId + '/edit', { 'name': this.name, 'location': this.location, 'gender': this.gender, 'category': this.category, 'age_range_max': this.ageRangeMax, 'age_range_min': this.ageRangeMin })
                    .then(response => {
                        console.log('Content Modified');

                        // Redirect to the content page
                        this.$router.push('/publisher/my-contents/' + this.contentId);
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });

            },
            loadContent: function() {
                // Show a loading
                this.pageLoading = true;

                // Clear previous status flags
                this.fail = false;

                // Make a request to the server
                axios.get('/api/publisher/content/' + this.contentId)
                    .then(response => {
                        this.content = response.data;

                        // Init form with content data
                        this.initForm();
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        this.pageLoading = false;
                    });
            },
            initForm: function () {
                this.name = this.content.name;
                this.location = this.content.location;
                this.type = this.content.type;
                this.category = this.content.content_targeting.content_category.id;
                this.ageRangeMin = this.content.content_targeting.age_range_min;
                this.ageRangeMax = this.content.content_targeting.age_range_max;

                // Gender
                if (this.content.content_targeting.gender === 'both') {
                    this.maleSelected = true;
                    this.femaleSelected = true;
                } else if (this.content.content_targeting.gender === 'female') {
                    this.femaleSelected = true;
                } else {
                    this.maleSelected = true;
                }
            }
        },
        watch: {
            '$route.params.id': function(id) {
                this.contentId = id;
                this.loadContent();
            }
        },
        computed: {
            gender: function() {
                if (this.maleSelected && this.femaleSelected) {
                    return 'both';
                } else if (!this.maleSelected && !this.femaleSelected) {
                    return null;
                } else if (this.maleSelected) {
                    return 'male';
                } else {
                    return 'female';
                }
            }
        },
        mounted() {
            console.log('Publisher - Edit Content mounted.');

            // Load Content
            this.loadContent();
        }
    }
</script>

<style scoped>

    .select-gender-card {
        z-index: 2;
        cursor: pointer;
    }

    .select-gender-card:hover, .select-gender-card.active {
        color: #fff;
        background: #3490dc !important;
    }

</style>
